//---------------------------------------------------------------------------------------------
//
// Archivo: main.cpp
//
// Propsito:
//    Formulario principal del proceso hijo para probar archivos proyectados en memoria.
//    Hace uso de la tcnica de herencia de descriptores para compartir datos entre una
//    aplicacin padre con sus procesos hijos.
//
// Autor:          http://www.lawebdejm.com
//
// Fecha:          01/02/2003
//
// Observaciones:  Clase creada en C++ Builder 6 para el artculo "Archivos proyectados en
//                 memoria", publicado en http://www.lawebdejm.com
//
// Copyright:      Este cdigo es de dominio pblico y se puede utilizar y/o mejorar siempre
//                 que SE HAGA REFERENCIA AL AUTOR ORIGINAL, ya sea a travs de estos
//                 comentarios o de cualquier otro modo.
//
//---------------------------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TChildForm *ChildForm;



//---------------------------------------------------------------------------
__fastcall TChildForm::TChildForm(TComponent* Owner) : TForm(Owner) { }



//---------------------------------------------------------------------------
void __fastcall TChildForm::FormCreate(TObject *Sender)
{
	TCHAR   szMap[64];
	HANDLE  hMapPadre;

	::ZeroMemory(szMap, 64);

	//
	// Se recupera la variable de entorno que contiene el descriptor
	// del objeto proyeccin en el proceso padre.
	//
	if ( GetEnvironmentVariable(VAR_MAP, szMap, 64) == 0 )
	{
		::MessageBox(GetActiveWindow(),
			"El proceso padre debe ser arrancado antes que los procesos hijos.",
			"Proceso Hijo", MB_ICONSTOP);
		this->Hide();
		Application->Terminate();
	}
	else
	{
		//
		// Ahora se crea la vista directamente, ya que el descriptor ha sido heredado a este
		// proceso.
		//
		hMapPadre = (HANDLE) atoi(szMap);

		m_vista = (LPSTR) ::MapViewOfFile(
				hMapPadre,
				FILE_MAP_WRITE, 0, 0, MAX_FILEMAPPING_CHARS );
		//
		// Una vez que no se va a utilizar ms un objeto proyeccin, puede cerrarse,
		// aunque las vistas s que se vayan a utilizar.
		//
		::CloseHandle(hMapPadre);

		if ( !m_vista )
			RaiseLastWin32Error();
	}
}



//---------------------------------------------------------------------------
void __fastcall TChildForm::Timer1Timer(TObject *Sender)
{
	//
	// Se copia el contenido de la vista en el memo, slo si la vista es vlida y
	// la bandera de modificacin est levantada.
	// Se puede comprobar el estado de la bandera de modificacin leyendo sobre el primer
	// byte de la vista.
	//
	if ( m_vista && m_vista[0] != 0 )
	{
		Memo1->Lines->SetText( m_vista + 1 );
		//
		// Ahora se baja la bandera de modificacin, porque el contenido ya lo hemos
		// copiado.
		//
		m_vista[0] = 0;
	}
}



//---------------------------------------------------------------------------
void __fastcall TChildForm::FormDestroy(TObject *Sender)
{
	if ( m_vista )
		::UnmapViewOfFile(m_vista);
}



//---------------------------------------------------------------------------
void __fastcall TChildForm::l_jmClick(TObject *Sender)
{
	::ShellExecute( ::GetForegroundWindow(),
		NULL,
		"http://www.lawebdejm.com/index.html",
		NULL,
		NULL,
		SW_NORMAL);

	l_jm->Font->Color = clPurple;
}
