//---------------------------------------------------------------------------------------------
//
// Archivo: main.cpp
//
// Propsito:
//    Formulario principal del proceso padre para probar archivos proyectados en memoria.
//    Hace uso de la tcnica de herencia de descriptores para compartir datos entre una
//    aplicacin padre con sus procesos hijos.
//
// Autor:          http://www.lawebdejm.com
//
// Fecha:          01/11/2002
//
// Observaciones:  Clase creada en C++ Builder 6 para el artculo "Archivos proyectados en
//                 memoria", publicado en http://www.lawebdejm.com
//
// Copyright:      Este cdigo es de dominio pblico y se puede utilizar y/o mejorar siempre
//                 que SE HAGA REFERENCIA AL AUTOR ORIGINAL, ya sea a travs de estos
//                 comentarios o de cualquier otro modo.
//
//---------------------------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "main.h"

#pragma package(smart_init)
#pragma resource "*.dfm"
TParentForm *ParentForm;



//---------------------------------------------------------------------------
__fastcall TParentForm::TParentForm(TComponent* Owner) : TForm(Owner)
{
   hProcesoHijo = 0;
}



//---------------------------------------------------------------------------
void __fastcall TParentForm::CrearProcesoHijo()
{
	SECURITY_ATTRIBUTES     sa;
	STARTUPINFO             si;
	PROCESS_INFORMATION     pi;

	//
	// inicializar los valores de SECURITY_ATTRIBUTES
	//
	::ZeroMemory( &sa, sizeof(sa) );
	sa.nLength        = sizeof(sa);
	sa.bInheritHandle = TRUE;

	//
	// inicializar los valores de STARTUPINFO
	//
	::ZeroMemory( &si, sizeof(si) );
	si.cb          = sizeof(si);
	si.wShowWindow = SW_NORMAL;

	//
	// Intento ejecutar el hijo en su propia carpeta
	//
	LPSTR   cmd = "..\\Hijo\\ProcesoHijo.exe";
	do {
		if ( !::CreateProcess( cmd, NULL, NULL, NULL, true,
							 0, NULL, NULL, &si, &pi ) )
		{
			//
			// Si no encuentra el archivo y es la primera vez,
			// lo intenta en la misma en que est el padre. Si es la segunda vez,
			// muestra el error
			//
			if ( ::GetLastError() == 2 )
				if ( cmd[0] == '.' )
					cmd = "ProcesoHijo.exe";
				else {
					::MessageBox( GetActiveWindow(),
							"No se ha encontrado el proceso hijo en el ejecutable \"ProcesoHijo.exe\".",
							"Proceso Padre", MB_ICONERROR );
					break;
				}
			else
				RaiseLastWin32Error();
		}
		else {
			//
			// si ejecuta correctamente el proceso, salimos el bucle
			//
			break;
		}
	}
	while ( true );

	//
	// Si el proceso se ha creado correctamente, se introducen los datos
	//
	if ( pi.hProcess != 0 ) {
		this->hProcesoHijo = pi.hProcess;

		//
		// Se introducen en el ListView los datos del proceso hijo
		//
		TListItem   *item;
		lv_procesos->Items->BeginUpdate();

		item = lv_procesos->Items->Add();
		item->Caption = IntToStr(lv_procesos->Items->Count);
		item->SubItems->Add( IntToStr( pi.hProcess ) );
		item->SubItems->Add( IntToStr( pi.dwProcessId ) );

		lv_procesos->Items->EndUpdate();
	}
}



//---------------------------------------------------------------------------
bool __fastcall TParentForm::TerminarProcesoHijo()
{
	if ( hProcesoHijo == NULL )
		return false;

	if ( !::TerminateProcess(hProcesoHijo, 0) )
		return false;
	else
		hProcesoHijo = NULL;

	lv_procesos->Items->Clear();

	return true;
}



//---------------------------------------------------------------------------
void __fastcall TParentForm::FormCreate(TObject *Sender)
{
	m_proyeccion = new CProyeccion;

	m_proyeccion->Abrir();
	this->Memo1Change(NULL);

	this->CrearProcesoHijo();
}



//---------------------------------------------------------------------------
void __fastcall TParentForm::FormDestroy(TObject *Sender)
{
   TerminarProcesoHijo();

   delete m_proyeccion;
}



//---------------------------------------------------------------------------
void __fastcall TParentForm::Memo1Change(TObject *Sender)
{
	m_proyeccion->Actualizar(Memo1->Text.c_str());
}



//---------------------------------------------------------------------------
void __fastcall TParentForm::l_jmClick(TObject *Sender)
{
	::ShellExecute( ::GetForegroundWindow(),
				   NULL,
				   "http://www.lawebdejm.com/index.html",
				   NULL,
				   NULL,
				   SW_NORMAL);

	l_jm->Font->Color = clPurple;
}



//---------------------------------------------------------------------------
void __fastcall TParentForm::m_TerminarProcesoClick(TObject *Sender)
{
   if ( !TerminarProcesoHijo() )
		::MessageBox( Handle, "No se ha encontrado el proceso hijo.",
					"Terminar proceso", MB_ICONWARNING );
}

void __fastcall TParentForm::Button1Click(TObject *Sender)
{
	CrearProcesoHijo();	
}
//---------------------------------------------------------------------------

